# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

from typing import Union
from datetime import datetime
from typing_extensions import Required, Annotated, TypedDict

from .._utils import PropertyInfo

__all__ = ["AirLoadPlanCountParams"]


class AirLoadPlanCountParams(TypedDict, total=False):
    est_dep_time: Required[Annotated[Union[str, datetime], PropertyInfo(alias="estDepTime", format="iso8601")]]
    """
    The current estimated time that the aircraft is planned to depart, in ISO 8601
    UTC format with millisecond precision. (YYYY-MM-DDTHH:MM:SS.sssZ)
    """
