# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

from typing import Union
from datetime import datetime
from typing_extensions import Required, Annotated, TypedDict

from .._utils import PropertyInfo

__all__ = ["DiplomaticClearanceTupleParams"]


class DiplomaticClearanceTupleParams(TypedDict, total=False):
    columns: Required[str]
    """
    Comma-separated list of valid field names for this data type to be returned in
    the response. Only the fields specified will be returned as well as the
    classification marking of the data, if applicable. See the ‘queryhelp’ operation
    for a complete list of possible fields.
    """

    first_dep_date: Required[Annotated[Union[str, datetime], PropertyInfo(alias="firstDepDate", format="iso8601")]]
    """
    The First Departure Date (FDD) the mission is scheduled for departure, in ISO
    8601 UTC format with millisecond precision. (YYYY-MM-DDTHH:MM:SS.sssZ)
    """
