# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

from typing import Union
from datetime import datetime
from typing_extensions import Required, Annotated, TypedDict

from .._utils import PropertyInfo

__all__ = ["EventEvolutionTupleParams"]


class EventEvolutionTupleParams(TypedDict, total=False):
    columns: Required[str]
    """
    Comma-separated list of valid field names for this data type to be returned in
    the response. Only the fields specified will be returned as well as the
    classification marking of the data, if applicable. See the ‘queryhelp’ operation
    for a complete list of possible fields.
    """

    event_id: Annotated[str, PropertyInfo(alias="eventId")]
    """
    (One or more of fields 'eventId, startTime' are required.) User-provided unique
    identifier of this activity or event. This ID should remain the same on
    subsequent updates in order to associate all records pertaining to the activity
    or event.
    """

    start_time: Annotated[Union[str, datetime], PropertyInfo(alias="startTime", format="iso8601")]
    """
    (One or more of fields 'eventId, startTime' are required.) The actual or
    estimated start time of the activity or event, in ISO 8601 UTC format.
    (YYYY-MM-DDTHH:MM:SS.sssZ)
    """
