# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

from typing import List
from typing_extensions import Literal, Required, Annotated, TypedDict

from .._utils import PropertyInfo

__all__ = ["SurfaceobstructionCreateParams"]


class SurfaceobstructionCreateParams(TypedDict, total=False):
    classification_marking: Required[Annotated[str, PropertyInfo(alias="classificationMarking")]]
    """Classification marking of the data in IC/CAPCO Portion-marked format."""

    data_mode: Required[Annotated[Literal["REAL", "TEST", "SIMULATED", "EXERCISE"], PropertyInfo(alias="dataMode")]]
    """Indicator of whether the data is REAL, TEST, SIMULATED, or EXERCISE data."""

    id_surface: Required[Annotated[str, PropertyInfo(alias="idSurface")]]
    """The unique identifier of the associated surface record.

    This field is required when posting, updating, or deleting a SurfaceObstruction
    record.
    """

    source: Required[str]
    """Source of the data."""

    id: str
    """Unique identifier of the record, auto-generated by the system."""

    advisory_required: Annotated[List[str], PropertyInfo(alias="advisoryRequired")]
    """
    Array of all vehicles that are affected by this obstruction at the surface
    end-point, and require an advisory for usage.
    """

    approval_required: Annotated[List[str], PropertyInfo(alias="approvalRequired")]
    """
    Array of all vehicles that are affected by this obstruction at the surface
    end-point, and require an approval for usage.
    """

    distance_from_center_line: Annotated[float, PropertyInfo(alias="distanceFromCenterLine")]
    """The distance from the surface center line to this obstruction, in feet."""

    distance_from_edge: Annotated[float, PropertyInfo(alias="distanceFromEdge")]
    """The distance from the surface edge to this obstruction, in feet."""

    distance_from_threshold: Annotated[float, PropertyInfo(alias="distanceFromThreshold")]
    """The distance from the surface threshold to this obstruction, in feet."""

    id_navigational_obstruction: Annotated[str, PropertyInfo(alias="idNavigationalObstruction")]
    """The unique identifier of the associated NavigationalObstruction record."""

    obstruction_desc: Annotated[str, PropertyInfo(alias="obstructionDesc")]
    """Description of this surface obstruction."""

    obstruction_height: Annotated[float, PropertyInfo(alias="obstructionHeight")]
    """The height above ground level of the surface obstruction, in feet."""

    obstruction_side_code: Annotated[str, PropertyInfo(alias="obstructionSideCode")]
    """
    A code that indicates which side of the surface end is affected by this
    obstruction.
    """

    origin: str
    """
    Originating system or organization which produced the data, if different from
    the source. The origin may be different than the source if the source was a
    mediating system which forwarded the data on behalf of the origin system. If
    null, the source may be assumed to be the origin.
    """
